#ifndef VAMPIRPLUGIN_H
#define VAMPIRPLUGIN_H
#include <QtGui>
#include "CubePlugin.h"
#include "Cube.h"
#include "CubeMetric.h"
#include "PluginServices.h"

class VampirConnecter;

class VampirPlugin : public QObject, CubePlugin
{
    Q_OBJECT
                             Q_INTERFACES( CubePlugin )
#if QT_VERSION >= 0x050000
    Q_PLUGIN_METADATA( IID "VampirPlugin" )
#endif


public:
    virtual QString
    name() const;
    virtual bool
    cubeOpened( PluginServices* service );

    virtual void
    cubeClosed();

    void
    version( int& major,
             int& minor,
             int& bugfix ) const;

    QString
    getHelpText() const;

private slots:
    void
    contextMenuIsShown( TreeType  type,
                        TreeItem* item );
    void
    globalValueChanged(const QString &name);
    void
    onShowMaxSeverity();
    void
    vampirSettings();   
private:
    PluginServices* service;
    TreeItem*       contextMenuItem;       // item on which the context menu has been invoked
    TreeType        contextMenuTreeType;   // tree type of contextMenuItem
    double          enter, exit;   // most severe event enter and exit time (from StatisticPlugin)

    QList<VampirConnecter *> connecterList; // list of current vampir connections
};

#endif // VAMPIRPLUGIN_H
