/****************************************************************************
**  CUBE        http://www.score-p.org/                                    **
**  SCALASCA    http://www.scalasca.org/                                   **
*****************************************************************************
**  Copyright (c) 1998-2015                                                **
**  Forschungszentrum Juelich GmbH, Juelich Supercomputing Centre          **
**                                                                         **
**  Copyright (c) 2009-2015                                                **
**  German Research School for Simulation Sciences GmbH,                   **
**  Laboratory for Parallel Programming                                    **
**                                                                         **
**  This software may be modified and distributed under the terms of       **
**  a BSD-style license.  See the COPYING file in the package base         **
**  directory for details.                                                 **
****************************************************************************/
#ifndef __ASSIGNMENT_EVALUATION_CPP
#define __ASSIGNMENT_EVALUATION_CPP 0

#include "CubeAssignmentEvaluation.h"

using namespace cube;
using namespace std;

AssignmentEvaluation::~AssignmentEvaluation()
{
    delete value;
    delete index;
}

double
AssignmentEvaluation::eval()
{
    memory->put( variable, index->eval(), value->eval(), kind );
    return 0.;
}



double
AssignmentEvaluation::eval( Cnode* cnode, CalculationFlavour cf, Sysres* sr, CalculationFlavour tf  )
{
    memory->put( variable, index->eval( cnode, cf, sr, tf ), value->eval( cnode, cf, sr, tf ), kind  );
    return 0.;
};



double
AssignmentEvaluation::eval( Cnode* cnode, CalculationFlavour cf )
{
    memory->put( variable, index->eval( cnode, cf ), value->eval( cnode, cf ), kind  );
    return 0.;
};


double
AssignmentEvaluation::eval( double arg1, double arg2 )
{
    memory->put( variable, index->eval( arg1, arg2 ), value->eval( arg1, arg2 ), kind  );
    return 0.;
};



double*
AssignmentEvaluation::eval_row( Cnode*             cnode,
                                CalculationFlavour cf )
{
    double* _tmp = value->eval_row( cnode, cf );
    memory->put( variable, index->eval( cnode, cf ), _tmp, kind  );
    return NULL;
}




#endif
